# object-history [![NPM version](https://badge.fury.io/js/object-history.svg)](http://badge.fury.io/js/object-history)  [![Build Status](https://travis-ci.org/PolicyStat/object-history.svg)](https://travis-ci.org/PolicyStat/object-history)  [![js-standard-style](https://raw.githubusercontent.com/feross/standard/master/badge.png)](https://github.com/feross/standard)

JavaScript Object history

## Behind the scenes

For cloning, [UltraDeepClone](https://github.com/imbcmdth/UltraDeepClone). For diff/apply, [changeset](https://github.com/eugeneware/changeset).

## Old browsers

Works in IE8 with `es5-shim`. Perhaps IE7, as well.

## API

### [History](lib/index.js#L23)

Gives birth to instances

* `initial` **{Object}**: The initial history point    
* `options` **{Object}**: `limit`: `{Number}` Remember this many backward points    

```js
var History = require('object-history')
var initial = {foo: 'bar', name: 'victoria'}
var history = new History(initial, {limit: 33})
```
### [.add](lib/prototype/add.js#L21)

Add a history point object

* `obj` **{Object}**: The history point    

```js
history.add({
  foo: 'bar',
  bar: 'foo'
})
```

### [.backward](lib/prototype/backward.js#L10)

Go back one history point

### [.forgetAllBackward](lib/prototype/forget-all-backward.js#L11)

Makes all backward history forgotten

### [.forgetAllForward](lib/prototype/forget-all-forward.js#L11)

Makes all forward history forgotten

### [.forward](lib/prototype/forward.js#L10)

Go forward one history point

### [.get](lib/prototype/get.js#L11)

* `returns` **{Object}**: "Current" history point  

### [.lengthBackward](lib/prototype/length-backward.js#L9)

* `returns` **{Number}**: Number of history points backwards  

### [.lengthForward](lib/prototype/length-forward.js#L9)

* `returns` **{Number}**: Number of history points forward

## License

Copyright © 2015 PolicyStat LLC

Released under the BSD-3-Clause license.

<!-- reflinks generated by verb-reflinks plugin -->

[verb]: https://github.com/assemble/verb
[template]: https://github.com/jonschlinkert/template
[assemble]: http://assemble.io
